+++
date = "2017-02-11T09:30:45+01:00"
title = "Welcome to OpenADK!"
type = "index"

+++

# OpenADK - **Open Source Appliance Development Kit**

# What is it?

A free construction kit for Embedded Devices. The resulting firmware boots up
**very fast**, is updateable without losing local configuration changes and the
root filesystem is mounted **read-only**. The default configuration creates a
**very small** linux system. The default configuration for software packages
and the system is **secure by default**.

# What is it, too?

A great menu based system to create a toolchain for a lot of architectures and
C library combinations. It supports Linux and bare-metal toolchains. The C
libraries uClibc-ng, musl, GNU libc and newlib are supported. You can create
toolchains for **44 different architectures**. Support for AARCH64, Alpha, ARC,
ARM, AVR32, Blackfin, C6X, CR16, CRIS, C-Sky, Epiphany, FR-V, FT32, H8/300,
HPPA, IA64, LM32, M32C, M32R, M68K, METAG, Microblaze, MIPS, MIPS64, MN10300,
Moxie, MSP430, NDS32, NIOS2, OR1K, PPC, PPC64, RISCV32, RISCV64, RX, S/390, SH,
SPARC, SPARC64, Tile, V850, X86, X86_64 and Xtensa. You can use it on any
computer running Linux, BSD, MacOS X or Windows (Cygwin) to create the
toolchains.

# Embedded Systems and more

There are only few samples for different embedded systems. The porting state
of the different embedded devices in OpenADK may vary from fully supported to
_just_ builds. OpenADK is a framework to help you to create a firmware
for your appliance. It might not be usable out-of-the box for the
different samples provided.

There are samples for Raspberry PI 0/1/2/3, Solidrun
Cubox-i/Hummingboard, Mikrotik Routerboard 532, PCEngines
Wrap/Alix/APU, Atmel NGW100 / Grasshopper and Hitachi EDOSK-2674.

Samples for different kind of system emulators or simulators are included, too.
There are samples for Qemu (different architectures), Synopsys NSIM, Aranym-M68K
and GDB simulator. 

# Development

Get the source via following command:

$ git clone git://openadk.org/git/openadk

Or via HTTPS (can be used with a proxy):

$ git clone https://git.openadk.org/git/openadk.git

Or just get a daily snapshot from here: https://snapshots.openadk.org/

GIT-Mirror 1: http://repo.or.cz/openadk.git

GIT-Mirror 2: https://github.com/wbx-github/openadk

# Documentation

For documentation see the OpenADK manual:

  +	[HTML](http://docs.openadk.org/html/manual.html)
  +	[PDF](http://docs.openadk.org/pdf/manual.pdf)
  +	[Text](http://docs.openadk.org/text/manual.text)

# Thanks

Thanks to following companies or people for hardware donations:

  +	Joerg Seitter - PCengines APU and Dragino
  +	Soldrun Ltd. - Hummingboard i1 + Clearfog ARM Board
  +	Wim Vandeputte - OpenMoko Freerunner
  +	Achim Marikar - STM32F4-Discovery
  +	Arcturus Networks Inc. - Blackfin + Coldfire Development Boards
  +	Ints M. - Raspberry PI Zero W + OrangePI Zero W


# Donations

If you want to help the project with money to compensate costs for hosting and
hardware, please use following link https://www.paypal.me/wbx

# Commercial Users

OpenADK is proven to be usable for commercial products. It is used in the
past by following companies:

  +	[Ableton](http://www.ableton.com)
  +	[CONET Solutions GmbH](http://www.conet.de)
  +	Steinbeis-Transferzentrum Gebäudeanalyse & -beratung
  +	[Viprinet](http://www.viprinet.com)

# Contact

  +	You can chat with us via IRC #openadk @ irc.oftc.net
  +	You can subscribe to the developer mailinglist and sent an e-mail to dev@openadk.org
  +	If you have any comments, patches or criticism you can also send directly an e-mail to wbx at openadk dot org

Have fun!
